{************************************************************************}
{ TADVSTRINGGRID ESBPCS EDITLINK components                              }
{ for Delphi 4.0,5.0,6.0 & C++Builder 4.0,5.0                            }
{ version 1.1 - rel. August 2001                                         }
{                                                                        }
{ written by TMS Software                                                }
{            copyright  1996-2001                                       }
{            Email : info@tmssoftware.com                                }
{            Web : http://www.tmssoftware.com                            }
{                                                                        }
{ ESBPCS : ESB Professional Computation Suite v2                         }
{          by ESB Consultancy                                            }
{          Web : www.esbconsult.com.au                                   }
{                                                                        }
{ The source code is given as is. The author is not responsible          }
{ for any possible damage done due to the use of this code.              }
{ The component can be freely used in any application. The complete      }
{ source code remains property of the author and may not be distributed, }
{ published, given or sold in any form as such. No parts of the source   }
{ code can be included in any other component or application without     }
{ written authorization of the author.                                   }
{************************************************************************}

unit esblinks;

interface

uses
  Controls, Graphics, SysUtils, Forms, AdvGrid, Windows, Classes, StdCtrls,
  ESBPCSGlobals,
  ESBPCSGlobals2,
  ESBPCSRegistry,
  ESBPCSCountries,
  ESBPCSEdit,
  ESBPCSNumEdit,
  ESBPCSDateTimeEdit,
  ESBPCSCurrEdit,
  ESBPCSSpinEdit,
  ESBPCSDateTimeSpinEdit,
  ESBPCSComplexEdit,
  ESBPCSPanel,
  ESBPCSFractionEdit,
  ESBPCSComboBox,
  ESBPCSDateTimeComboBox,
  ESBPCSCurrComboBox,
  ESBPCSCurrency,
  ESBPCSCountryComboBox, dialogs;

type
  TESBBaseEditLink = class(TEditLink)
  private
    FEdit: TESBBaseEdit;
    FNumPadDecimal: Boolean;
    FCharCase: TEditCharCase;
  protected
    procedure EditExit(Sender: TObject);
    procedure CreateInstance(AParent: TWinControl); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue: string; override;
    procedure SetEditorValue(s: string); override;
    function GetEditControl: TWinControl; override;
    procedure SetProperties; override;
  published
    property NumPadDecimal: Boolean read FNumPadDecimal write FNumPadDecimal;
    property CharCase: TEditCharCase read FCharCase write FCharCase;
  end;

  TESBBaseSignEditLink = class(TESBBaseEditLink)
  private
    FColorFontNeg: TColor;
    FColorFontPos: TColor;
  public
    constructor Create(AOwner:TComponent); override;
    procedure SetProperties; override;
  published
    property ColorFontPos: TColor read FColorFontPos write FColorFontPos default clWindowText;
    property ColorFontNeg: TColor read FColorFontNeg write FColorFontNeg default clWindowText;
  end;

  TESBComplexEditLink = class(TEditLink)
  private
    FEdit: TESBComplexEdit;
  protected
    procedure EditExit(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue: string; override;
    procedure SetEditorValue(s: string); override;
    function GetEditControl: TWinControl; override;
  end;

  TESBFractionEditLink = class(TEditLink)
  private
    FEdit: TESBFractionEdit;
  protected
    procedure EditExit(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue: string; override;
    procedure SetEditorValue(s: string); override;
    function GetEditControl: TWinControl; override;
  end;

  TESBPCSEditLink = class(TEditLink)
  private
    FEdit: TESBPCSEdit;
    FNumPadDecimal: Boolean;
    FCharCase: TEditCharCase;
  protected
    procedure EditExit(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue: string; override;
    procedure SetEditorValue(s: string); override;
    function GetEditControl: TWinControl; override;
    procedure SetProperties; override;
  published
    property NumPadDecimal: Boolean read FNumPadDecimal write FNumPadDecimal;
    property CharCase: TEditCharCase read FCharCase write FCharCase;
  end;

  TESBPosEditLink = class(TESBBaseSignEditLink)
  private
    FShowPosSign: Boolean;
    FShowThousandSeparators: Boolean;
  protected
    procedure CreateInstance(AParent:TWinControl); override;
  public
    procedure SetProperties; override;
  published
    property ShowPosSign: Boolean read FShowPosSign write FShowPosSign;
    property ShowThousandSeparators: Boolean read FShowThousandSeparators write FShowThousandSeparators;
  end;

  TESBIntEditLink = class(TESBPosEditLink)
  protected
    procedure CreateInstance(aParent:TWinControl); override;
  end;

  TESBPosFloatEditLink = class(TESBPosEditLink)
  private
    FFullAccuracy: Boolean;
    FDecimalPlaces: Integer;
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  public
    procedure SetProperties; override;
  published
    property DecimalPlaces: Integer read FDecimalPlaces write FDecimalPlaces;
    property FullAccuracy: Boolean read FFullAccuracy write FFullAccuracy;
  end;

  TESBFloatEditLink = class(TESBPosFloatEditLink)
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  end;

  TESBSciFloatEditLink = class(TESBPosFloatEditLink)
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  end;

  TESBPercentEditLink = class(TESBFloatEditLink)
  private
    FShowPercent: Boolean;
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  public
    procedure SetProperties; override;
  published
    property ShowPercent: Boolean read FShowPercent write FShowPercent;  
  end;

  TESBIPEditLink = class(TESBBaseEditLink)
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  end;

  TESBHexEditLink = class(TESBBaseEditLink)
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  end;

  TESBYearEditLink = class(TESBBaseEditLink)
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  end;

  TESBDateEditLink = class(TESBBaseEditLink)
  private
    FFormat: string;
    FFormatType: TESBDateFormatType;
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure SetProperties; override;
  published
    property Format: string read FFormat write FFormat;
    property FormatType: TESBDateFormatType read FFormatType write FFormatType;
  end;

  TESBTimeEditLink = class(TESBBaseEditLink)
  private
    FFormat: string;
    FFormatType: TESBTimeFormatType;
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure SetProperties; override;
  published
    property Format: string read FFormat write FFormat;
    property FormatType: TESBTimeFormatType read FFormatType write FFormatType;
  end;

  TESBDOWEditLink = class(TESBBaseEditLink)
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  end;

  TESBMonthEditLink = class(TESBBaseEditLink)
  private
    FMonthFormat: TESBMonthFormatType;
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  public
    procedure SetProperties; override;
  published
    property MonthFormat: TESBMonthFormatType read FMonthFormat write FMonthFormat;
  end;

  TESBCurrEditLink = class(TESBBaseSignEditLink)
  private
    FCurrencyStr: string;
    FCurrencyFormat: TCurrencyFormatType;
    FNegativeFormat: TNegativeFormatType;
    FFormatType: TESBCurrencyFormatType;
    FFullAccuracy: Boolean;
    FDecimalPlaces: Integer;
    FShowThousandSeparators: Boolean;
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure SetProperties; override;
  published
    property CurrencyFormat: TCurrencyFormatType read FCurrencyFormat write FCurrencyFormat;
    property CurrencyStr: string read FCurrencyStr write FCurrencyStr;
    property DecimalPlaces: Integer read FDecimalPlaces write FDecimalPlaces;
    property FormatType: TESBCurrencyFormatType read FFormatType write FFormatType;
    property FullAccuracy: Boolean read FFullAccuracy write FFullAccuracy;
    property NegativeFormat: TNegativeFormatType read FNegativeFormat write FNegativeFormat;
    property ShowThousandSeparators: Boolean read FShowThousandSeparators write FShowThousandSeparators;
  end;

  TESBLongCurrEditLink = class(TESBCurrEditLink)
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  end;

  TESBCurrencyEditLink = class(TESBCurrEditLink)
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  end;

  TESBBaseSpinEditLink = class(TEditLink)
  private
    FEdit: TESBCustomBtnPanel;
  protected
    procedure EditExit(Sender: TObject);
    procedure CreateInstance(AParent: TWinControl); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue: string; override;
    procedure SetEditorValue(s: string); override;
    function GetEditControl:TWinControl; override;
  end;

  TESBPosSpinEditLink = class(TESBBaseSpinEditLink)
  private
    FEditorEnabled: Boolean;
    FFlatSpinBtns: Boolean;
    FShowThousandSeparators: Boolean;
    FInterval: Integer;
    FStep: Integer;
    FMin: Integer;
    FMax: Integer;
  protected
    procedure CreateInstance(aParent:TWinControl); override;
  public
    procedure CreateEditor(AParent: TWinControl); override;
    constructor Create(AOwner: TComponent); override;
    procedure SetEditorValue(s:string); override;
    function GetEditorValue:string; override;
    procedure SetProperties; override;
  published
    property EditorEnabled: Boolean read FEditorEnabled write FEditorEnabled;
    property FlatSpinBtns: Boolean read FFlatSpinBtns write FFlatSpinBtns;
    property Interval: Integer read FInterval write FInterval;
    property Max: Integer read FMax write FMax;
    property Min: Integer read FMin write FMin;
    property ShowThousandSeparators: Boolean read FShowThousandSeparators write FShowThousandSeparators;
    property Step: Integer read FStep write FStep;
  end;

  TESBIntSpinEditLink = class(TESBBaseSpinEditLink)
  private
    FEditorEnabled: Boolean;
    FFlatSpinBtns: Boolean;
    FShowThousandSeparators: Boolean;
    FInterval: Integer;
    FStep: Integer;
    FColorFontNeg: TColor;
    FColorFontPos: TColor;
    FMin: Integer;
    FMax: Integer;
  protected
    procedure CreateInstance(AParent:TWinControl); override;
  public
    procedure CreateEditor(AParent: TWinControl); override;
    constructor Create(AOwner: TComponent); override;
    procedure SetEditorValue(s:string); override;
    function GetEditorValue:string; override;
    procedure SetProperties; override;
  published
    property ColorFontNeg: TColor read FColorFontNeg write FColorFontNeg;
    property ColorFontPos: TColor read FColorFontPos write FColorFontPos;    
    property EditorEnabled: Boolean read FEditorEnabled write FEditorEnabled;
    property FlatSpinBtns: Boolean read FFlatSpinBtns write FFlatSpinBtns;
    property Interval: Integer read FInterval write FInterval;
    property Max: Integer read FMax write FMax;
    property Min: Integer read FMin write FMin;
    property ShowThousandSeparators: Boolean read FShowThousandSeparators write FShowThousandSeparators;
    property Step: Integer read FStep write FStep;
  end;

  TESBFloatSpinEditLink = class(TESBBaseSpinEditLink)
  private
    FFullAccuracy: Boolean;
    FFlatSpinBtns: Boolean;
    FEditorEnabled: Boolean;
    FShowThousandSeparators: Boolean;
    FStep: Double;
    FInterval: Integer;
    FMax: Integer;
    FMin: Integer;
    FDecimalPlaces: Integer;
    FColorFontNeg: TColor;
    FColorFontPos: TColor;
  protected
    procedure CreateInstance(AParent:TWinControl); override;
  public
    procedure CreateEditor(AParent: TWinControl); override;
    constructor Create(AOwner: TComponent); override;
    procedure SetEditorValue(s:string); override;
    function GetEditorValue:string; override;
    procedure SetProperties; override;
  published
    property ColorFontNeg: TColor read FColorFontNeg write FColorFontNeg;
    property ColorFontPos: TColor read FColorFontPos write FColorFontPos;
    property DecimalPlaces: Integer read FDecimalPlaces write FDecimalPlaces;
    property EditorEnabled: Boolean read FEditorEnabled write FEditorEnabled;
    property FlatSpinBtns: Boolean read FFlatSpinBtns write FFlatSpinBtns;
    property FullAccuracy: Boolean read FFullAccuracy write FFullAccuracy;
    property Interval: Integer read FInterval write FInterval;
    property Max: Integer read FMax write FMax;
    property Min: Integer read FMin write FMin;
    property ShowThousandSeparators: Boolean read FShowThousandSeparators write FShowThousandSeparators;
    property Step: Double read FStep write FStep;
  end;

  TESBYearSpinEditLink = class(TESBBaseSpinEditLink)
  private
    FFlatSpinBtns: Boolean;
    FEditorEnabled: Boolean;
  protected
    procedure CreateInstance(AParent: TWinControl); override;
  public
    procedure CreateEditor(AParent: TWinControl); override;
    procedure SetEditorValue(s:string); override;
    function GetEditorValue:string; override;
    procedure SetProperties; override;
  published
    property EditorEnabled: Boolean read FEditorEnabled write FEditorEnabled;
    property FlatSpinBtns: Boolean read FFlatSpinBtns write FFlatSpinBtns;
  end;

  TESBMonthSpinEditLink = class(TEditLink)
  private
    FEdit: TESBMonthSpinEdit;
    FFlatSpinBtns: Boolean;
    FMonthFormat: TESBMonthFormatType;
    FEditorEnabled: Boolean;
    FInterval: Integer;
  protected
    procedure EditExit(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue:string; override;
    procedure SetEditorValue(s: string); override;
    function GetEditControl: TWinControl; override;
    procedure SetProperties; override;
  published
    property EditorEnabled: Boolean read FEditorEnabled write FEditorEnabled;
    property FlatSpinBtns: Boolean read FFlatSpinBtns write FFlatSpinBtns;
    property Interval: Integer read FInterval write FInterval;
    property MonthFormat: TESBMonthFormatType read FMonthFormat write FMonthFormat;
  end;

  TESBDOWSpinEditLink = class(TEditLink)
  private
    FEdit: TESBDOWSpinEdit;
    FFlatSpinBtns: Boolean;
    FEditorEnabled: Boolean;
    FInterval: Integer;
    FDOWFormat: TESBDOWFormatType;
  protected
    procedure EditExit(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    procedure SetEditorValue(s: string); override;
    function GetEditorValue: string; override;
    function GetEditControl: TWinControl; override;
    procedure SetProperties; override;
  published
    property EditorEnabled: Boolean read FEditorEnabled write FEditorEnabled;
    property FlatSpinBtns: Boolean read FFlatSpinBtns write FFlatSpinBtns;
    property Interval: Integer read FInterval write FInterval;
    property DOWFormat: TESBDOWFormatType read FDOWFormat write FDOWFormat;
  end;

  TESBMonthComboBoxEditLink = class(TEditLink)
  private
    FEdit: TESBMonthComboBox;
    FMonthFormat: TESBMonthFormatType;
  protected
    procedure EditExit(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue:string; override;
    procedure SetEditorValue(s:string); override;
    function GetEditControl:TWinControl; override;
    procedure SetRect(r:TRect); override;
    procedure SetProperties; override;
  published
    property MonthFormat: TESBMonthFormatType read FMonthFormat write FMonthFormat;
  end;

  TESBDowComboBoxEditLink = class(TEditLink)
  private
    FEdit: TESBDowComboBox;
    FDOWFormat: TESBDOWFormatType;
  protected
    procedure EditExit(Sender:TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue:string; override;
    procedure SetEditorValue(s:string); override;
    function GetEditControl: TWinControl; override;
    procedure SetRect(r: TRect); override;
    procedure SetProperties; override;
  published
    property DOWFormat: TESBDOWFormatType read FDOWFormat write FDOWFormat;
  end;

  TESBTZComboBoxEditLink = class(TEditLink)
  private
    FEdit: TESBTZComboBox;
    FDaylightBIAS: Integer;
    FDaylightName: string;
    FDaylightDate: string;
  protected
    procedure EditExit(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue: string; override;
    procedure SetEditorValue(s: string); override;
    function GetEditControl: TWinControl; override;
    procedure SetRect(r: TRect); override;
    procedure SetProperties; override;
  published
    property DaylightBIAS: Integer read FDaylightBIAS write FDaylightBIAS;
    property DaylightDate: string read FDaylightDate write FDaylightDate;
    property DaylightName: string read FDaylightName write FDaylightName;
  end;

  TESBEMUComboBoxEditLink = class(TEditLink)
  private
    FEdit: TESBEMUComboBox;
    FEMUFormat: TESBEMUFormatType;
  protected
    procedure EditExit(Sender:TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue: string; override;
    procedure SetEditorValue(s:string); override;
    function GetEditControl:TWinControl; override;
    procedure SetRect(r: TRect); override;
    procedure SetProperties; override;
  published
    property EMUFormat: TESBEMUFormatType read FEMUFormat write FEMUFormat;
  end;

  TESBCountryComboBoxEditLink = class(TEditLink)
  private
    FEdit: TESBCountryComboBox;
  protected
    procedure EditExit(Sender:TObject);
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue: string; override;
    procedure SetEditorValue(s:string); override;
    function GetEditControl:TWinControl; override;
    procedure SetRect(r: TRect); override;
    procedure SetProperties; override;
  published
  end;


  {
  TESBCalcEditLink = class(TEditLink)
  private
    FEdit: TESBCalcEdit;
  protected
    procedure EditExit(sender: TObject);
    procedure CreateInstance(AParent: TWinControl); virtual;
  public
    constructor Create(AOwner:TComponent); override;
    procedure CreateEditor(aParent:TWinControl); override;
    procedure DestroyEditor; override;
    function GetEditorValue:string; override;
    procedure SetEditorValue(s:string); override;
    function GetEditControl:TWinControl; override;
    procedure SetProperties; override;
  published
  end;
  }

procedure Register;

implementation

{ TESBBaseSpinEditLink }

constructor TESBBaseSpinEditLink.Create(aOwner: TComponent);
begin
  inherited;
  WantKeyLeftRight := True;
  WantKeyHomeEnd := True;
  WantKeyUpDown := True;
end;

procedure TESBBaseSpinEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  CreateInstance(AParent);
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
  FEdit.ColorBorderFocus := clWindow;
  FEdit.ColorBorderUnFocus := clWindow;
end;

procedure TESBBaseSpinEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBBaseSpinEdit.Create(AParent);
end;

procedure TESBBaseSpinEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBBaseSpinEditLink.EditExit(sender: TObject);
begin
  HideEditor;
end;

function TESBBaseSpinEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;


function TESBBaseSpinEditLink.GetEditorValue: string;
begin
end;

procedure TESBBaseSpinEditLink.SetEditorValue(s: string);
begin
end;


{ TESBPCSEditLink }

constructor TESBPCSEditLink.Create(aOwner: TComponent);
begin
 inherited;
 WantKeyLeftRight:=true;
 WantKeyHomeEnd:=true;
end;

procedure TESBPCSEditLink.CreateEditor(aParent: TWinControl);
begin
  inherited;
  FEdit := TESBPCSEdit.Create(aParent);
  FEdit.OnKeydown:= EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
  FEdit.ColorBorderFocus := clwindow;
  FEdit.ColorBorderUnFocus := clwindow;
  FEdit.BorderStyle := bsNone;
end;

procedure TESBPCSEditLink.DestroyEditor;
begin
 if assigned(FEdit) then FEdit.Free;
 FEdit:=nil;
 inherited;
end;

procedure TESBPCSEditLink.EditExit(sender: TObject);
begin
  HideEditor;
end;

function TESBPCSEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBPCSEditLink.GetEditorValue: string;
begin
  Result := FEdit.Text;
end;

procedure TESBPCSEditLink.SetEditorValue(s: string);
begin
  FEdit.Text := s;
end;

procedure TESBPCSEditLink.SetProperties;
begin
  inherited;
  FEdit.NumPadDecimal := FNumPadDecimal;
  FEdit.CharCase := FCharCase;
end;

{ TESBPosEditLink }

procedure TESBPosEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBPosEdit.Create(AParent);
end;

procedure TESBPosEditLink.SetProperties;
begin
  inherited;
  TESBPosEdit(FEdit).ShowPosSign := FShowPosSign;
  TESBPosEdit(FEdit).ShowThousandSeparators := FShowThousandSeparators;
end;

{ TESBIntEditLink }

procedure TESBIntEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBIntEdit.Create(AParent);
end;

{ TESBBaseEditLink }

constructor TESBBaseEditLink.Create(AOwner: TComponent);
begin
  inherited;
  WantKeyLeftRight := True;
  WantKeyHomeEnd := True;
end;

procedure TESBBaseEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  CreateInstance(AParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
  FEdit.ColorBorderFocus := clwindow;
  FEdit.ColorBorderUnFocus := clwindow;
  FEdit.BorderStyle := bsNone;
end;

procedure TESBBaseEditLink.CreateInstance(aParent:TWinControl);
begin
  FEdit := TESBBaseEdit.Create(aParent);
end;

procedure TESBBaseEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBBaseEditLink.EditExit(sender: TObject);
begin
  HideEditor;
end;

function TESBBaseEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBBaseEditLink.GetEditorValue: string;
begin
  Result := FEdit.Text;
end;


procedure TESBBaseEditLink.SetEditorValue(s: string);
begin
  FEdit.Text := s;
end;

procedure TESBBaseEditLink.SetProperties;
begin
  inherited;
  FEdit.NumPadDecimal := FNumPadDecimal;
  FEdit.CharCase := FCharCase;
end;

{ TESBBaseSignEditLink }

constructor TESBBaseSignEditLink.Create(AOwner: TComponent);
begin
  inherited;
  FColorFontNeg := clRed;
  FColorFontPos := clWindowText;
end;

procedure TESBBaseSignEditLink.SetProperties;
begin
  inherited;
  FEdit.ColorFontNeg := FColorFontNeg;
  FEdit.ColorFontPos := FColorFontPos;
end;


{ TESBSciFloatEditLink }

procedure TESBSciFloatEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBSciFloatEdit.Create(aParent);
end;

{ TESBFloatEditLink }

procedure TESBFloatEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBFloatEdit.Create(aParent);
end;

{ TESBPercentEditLink }

procedure TESBPercentEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBPercentEdit.Create(AParent);
end;

procedure TESBPercentEditLink.SetProperties;
begin
  inherited;
  TESBPercentEdit(FEdit).ShowPercent := FShowPercent;
end;

{ TESBPosFloatEditLink }

procedure TESBPosFloatEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBPosFloatEdit.Create(AParent);
end;

procedure TESBPosFloatEditLink.SetProperties;
begin
  inherited;
  TESBPosFloatEdit(FEdit).FullAccuracy := FFullAccuracy;
  TESBPosFloatEdit(FEdit).DecimalPlaces := FDecimalPlaces;
end;

{ TESBIPEditLink }

procedure TESBIPEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBIPEdit.Create(AParent);
end;

{ TESBHexEditLink }

procedure TESBHexEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBHexEdit.Create(AParent);
end;

{ TESBYearEditLink }

procedure TESBYearEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBYearEdit.Create(aParent);
end;

{ TESBDateEditLink }

constructor TESBDateEditLink.Create(AOwner: TComponent);
begin
  inherited;
  FFormat := 'd/MM/yyyy';
end;

procedure TESBDateEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBDateEdit.Create(AParent);
end;

procedure TESBDateEditLink.SetProperties;
begin
  inherited;
  TESBDateEdit(FEdit).Format := FFormat;
  TESBDateEdit(FEdit).FormatType := FFormatType;
end;

{ TESBTimeEditLink }

constructor TESBTimeEditLink.Create(AOwner: TComponent);
begin
  inherited;
  FFormat := 'hh:mm';
end;

procedure TESBTimeEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBTimeEdit.Create(AParent);
end;

procedure TESBTimeEditLink.SetProperties;
begin
  inherited;
  TESBTimeEdit(FEdit).Format := FFormat;
  TESBTimeEdit(FEdit).FormatType := FFormatType;
end;

{ TESBDOWEditLink }

procedure TESBDOWEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBDOWEdit.Create(AParent);
end;

{ TESBMonthEditLink }

procedure TESBMonthEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBMonthEdit.Create(AParent);
end;

procedure TESBMonthEditLink.SetProperties;
begin
  inherited;
  TESBMonthEdit(FEdit).MonthFormat := FMonthFormat;
end;

{ TESBCurrEditLink }

constructor TESBCurrEditLink.Create(AOwner: TComponent);
begin
  inherited;
  FCurrencyStr := '$';
end;

procedure TESBCurrEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBCurrEdit.Create(AParent);
end;

procedure TESBCurrEditLink.SetProperties;
begin
  inherited;
  TESBCurrEdit(FEdit).CurrencyFormat := FCurrencyFormat;
  TESBCurrEdit(FEdit).CurrencyStr := FCurrencyStr;
  TESBCurrEdit(FEdit).NegativeFormat := FNegativeFormat;
  TESBCurrEdit(FEdit).FormatType := FFormatType;
  TESBCurrEdit(FEdit).ShowThousandSeparators := FShowThousandSeparators;
  TESBCurrEdit(FEdit).FullAccuracy := FFullAccuracy;
  TESBCurrEdit(FEdit).DecimalPlaces := FDecimalPlaces; 
end;

{ TESBLongCurrEditLink }

procedure TESBLongCurrEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBLongCurrEdit.Create(AParent);
end;

{ TESBCurrencyEditLink }

procedure TESBCurrencyEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBCurrencyEdit.Create(AParent);
end;

{ TESBComplexEditLink }

constructor TESBComplexEditLink.Create(AOwner: TComponent);
begin
  inherited;
  WantKeyLeftRight := True;
  WantKeyHomeEnd := True;
end;

procedure TESBComplexEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  FEdit := TESBComplexEdit.Create(AParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
  FEdit.ColorBorderFocus := clwindow;
  FEdit.ColorBorderUnFocus := clwindow;
  FEdit.Flat := True;
  WantKeyLeftRight:=true;
  WantKeyHomeEnd:=true;
end;

procedure TESBComplexEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBComplexEditLink.EditExit(Sender: TObject);
begin
  HideEditor;
end;

function TESBComplexEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBComplexEditLink.GetEditorValue: string;
begin
  Result := FloatToStr(FEdit.RealPortion)+':'+FloatToStr(FEdit.ImaginaryPortion);
end;

procedure TESBComplexEditLink.SetEditorValue(s: string);
begin
  if (s <> '') and (Pos(':',s )> 0) then
  begin
    FEdit.RealPortion := StrToFloat(Copy(s,1,Pos(':',s)-1));
    FEdit.ImaginaryPortion := StrToFloat(Copy(s,Pos(':',s)+1,Length(s)));
  end;
end;

{ TESBFractionEditLink }

constructor TESBFractionEditLink.Create(aOwner: TComponent);
begin
  inherited;
  WantKeyLeftRight := True;
  WantKeyHomeEnd := True;
end;

procedure TESBFractionEditLink.CreateEditor(aParent: TWinControl);
begin
  inherited;
  FEdit := TESBFractionEdit.Create(aParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
  FEdit.ColorBorderFocus := clwindow;
  FEdit.ColorBorderUnFocus := clwindow;
  FEdit.Flat := True;
  WantKeyLeftRight := True;
  WantKeyHomeEnd := True;
end;

procedure TESBFractionEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBFractionEditLink.EditExit(Sender: TObject);
begin
  HideEditor;
end;

function TESBFractionEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBFractionEditLink.GetEditorValue: string;
begin
  Result := IntToStr(FEdit.Numerator) + '/' + IntToStr(FEdit.Denominator);
end;

procedure TESBFractionEditLink.SetEditorValue(s: string);
begin
  if (s <> '') and (Pos('/',s) > 0) then
  begin
    FEdit.Numerator := StrToInt(Copy(s,1,pos('/',s)-1));
    FEdit.Denominator := StrToInt(Copy(s,pos('/',s)+1,Length(s)));
  end;
end;

{ TESBPosSpinEditLink }

constructor TESBPosSpinEditLink.Create(AOwner: TComponent);
begin
  inherited;
  FInterval := 100;
  FStep := 1;
  FMin := 0;
  FMax := 100;
end;

procedure TESBPosSpinEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  TESBPosSpinEdit(FEdit).OnKeydown := EditKeyDown;
  TESBPosSpinEdit(FEdit).OnExit := EditExit;
end;

procedure TESBPosSpinEditLink.CreateInstance(AParent: TWinControl);
begin
  TESBPosSpinEdit(FEdit) := TESBPosSpinEdit.Create(AParent);
end;

function TESBPosSpinEditLink.GetEditorValue: string;
begin
  Result := IntToStr(TESBPosSpinEdit(FEdit).Value);
end;

procedure TESBPosSpinEditLink.SetEditorValue(s: string);
begin
  if (s = '') then TESBPosSpinEdit(FEdit).Value := 0 else
  TESBPosSpinEdit(FEdit).value := StrToInt(s);
end;

procedure TESBPosSpinEditLink.SetProperties;
begin
  inherited;
  TESBPosSpinEdit(FEdit).FlatEdit := True;
  TESBPosSpinEdit(FEdit).EditorEnabled := FEditorEnabled;
  TESBPosSpinEdit(FEdit).FlatSpinBtns := FFlatSpinBtns;
  TESBPosSpinEdit(FEdit).Interval := FInterval;
  TESBPosSpinEdit(FEdit).Step := FStep;
  TESBPosSpinEdit(FEdit).Max := FMax;
  TESBPosSpinEdit(FEdit).Min := FMin;
end;

{ TESBIntSpinEditLink }

constructor TESBIntSpinEditLink.Create(AOwner: TComponent);
begin
  inherited;
  FInterval := 100;
  FColorFontNeg := clRed;
  FColorFontPos := clWindowText;
  FStep := 1;
  FMin := 0;
  FMax := 100;
end;

procedure TESBIntSpinEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  TESBIntSpinEdit(FEdit).OnKeydown := EditKeyDown;
  TESBIntSpinEdit(FEdit).OnExit := EditExit;
end;

procedure TESBIntSpinEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBIntSpinEdit.Create(AParent);
end;

function TESBIntSpinEditLink.GetEditorValue: string;
begin
  Result := IntToStr(TESBIntSpinEdit(FEdit).Value);
end;

procedure TESBIntSpinEditLink.SetEditorValue(s: string);
begin
  if (s = '') then TESBIntSpinEdit(FEdit).Value := 0 else
  TESBIntSpinEdit(FEdit).Value := StrToInt(s);
end;

procedure TESBIntSpinEditLink.SetProperties;
begin
  inherited;
  TESBIntSpinEdit(FEdit).FlatEdit := True;
  TESBIntSpinEdit(FEdit).EditorEnabled := FEditorEnabled;
  TESBIntSpinEdit(FEdit).FlatSpinBtns := FFlatSpinBtns;
  TESBIntSpinEdit(FEdit).Interval := FInterval;
  TESBIntSpinEdit(FEdit).Step := FStep;
  TESBIntSpinEdit(FEdit).Max := FMax;
  TESBIntSpinEdit(FEdit).Min := FMin;
  TESBIntSpinEdit(FEdit).ColorFontNeg := FColorFontNeg;
  TESBIntSpinEdit(FEdit).ColorFontPos := FColorFontPos;
end;

{ TESBFloatSpinEditLink }

constructor TESBFloatSpinEditLink.Create(AOwner: TComponent);
begin
  inherited;
  FDecimalPlaces := 4;
  FStep := 1;
  FMin := 0;
  FMax := 100;
  FInterval := 100;
end;

procedure TESBFloatSpinEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  TESBFloatSpinEdit(FEdit).OnKeydown := EditKeyDown;
  TESBFloatSpinEdit(FEdit).OnExit := EditExit;
end;

procedure TESBFloatSpinEditLink.CreateInstance(aParent: TWinControl);
begin
  FEdit := TESBFloatSpinEdit.Create(AParent);
end;

function TESBFloatSpinEditLink.GetEditorValue: string;
begin
  Result := TESBFloatSpinEdit(FEdit).Text;
end;

procedure TESBFloatSpinEditLink.SetEditorValue(s: string);
begin
  if (s = '') then TESBFloatSpinEdit(FEdit).Value := 0 else
  TESBFloatSpinEdit(FEdit).Value := StrToFloat(s);
end;

procedure TESBFloatSpinEditLink.SetProperties;
begin
  inherited;
  TESBFloatSpinEdit(FEdit).FlatEdit := True;
  TESBFloatSpinEdit(FEdit).EditorEnabled := FEditorEnabled;
  TESBFloatSpinEdit(FEdit).FlatSpinBtns := FFlatSpinBtns;
  TESBFloatSpinEdit(FEdit).Interval := FInterval;
  TESBFloatSpinEdit(FEdit).Step := FStep;
  TESBFloatSpinEdit(FEdit).Max := FMax;
  TESBFloatSpinEdit(FEdit).Min := FMin;
  TESBFloatSpinEdit(FEdit).ColorFontNeg := FColorFontNeg;
  TESBFloatSpinEdit(FEdit).ColorFontPos := FColorFontPos;
  TESBFloatSpinEdit(FEdit).FullAccuracy := FFullAccuracy;
  TESBFloatSpinEdit(FEdit).DecimalPlaces := FDecimalPlaces;
end;

{ TESBYearSpinEditLink }

procedure TESBYearSpinEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  TESBYearSpinEdit(FEdit).OnKeydown := EditKeyDown;
  TESBYearSpinEdit(FEdit).OnExit := EditExit;
end;

procedure TESBYearSpinEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBYearSpinEdit.Create(AParent);
end;

function TESBYearSpinEditLink.GetEditorValue: string;
begin
  Result := IntToStr(TESBYearSpinEdit(FEdit).Year);
end;

procedure TESBYearSpinEditLink.SetEditorValue(s: string);
begin
  if (s = '') then TESBYearSpinEdit(FEdit).Year:=0 else
  TESBYearSpinEdit(FEdit).Year := StrToInt(s);
end;

procedure TESBYearSpinEditLink.SetProperties;
begin
  inherited;
  TESBYearSpinEdit(FEdit).FlatEdit := True;  
  TESBYearSpinEdit(FEdit).FlatSpinBtns := FFlatSpinBtns;
  TESBYearSpinEdit(FEdit).EditorEnabled := FEditorEnabled;  
end;

{ TESBMonthSpinEditLink }

constructor TESBMonthSpinEditLink.Create(AOwner: TComponent);
begin
  inherited;
  WantKeyLeftRight := True;
  WantKeyUpDown := True;
  WantKeyHomeEnd := True;
  FInterval := 100;
  FMonthFormat := emfShortMonth;
end;

procedure TESBMonthSpinEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  FEdit := TESBMonthSpinEdit.Create(aParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
  FEdit.ColorBorderFocus := clWindow;
  FEdit.ColorBorderUnFocus := clWindow;
  FEdit.FlatEdit := true;
end;

procedure TESBMonthSpinEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBMonthSpinEditLink.EditExit(Sender: TObject);
begin
  HideEditor;
end;

function TESBMonthSpinEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBMonthSpinEditLink.GetEditorValue: string;
begin
  case MonthFormat of
  emfShortMonth: Result := TESBMonthSpinEdit(FEdit).MonthShort;
  emfLongMonth: Result := TESBMonthSpinEdit(FEdit).MonthLong;
  emfNumeric: Result := IntToStr(TESBMonthSpinEdit(FEdit).Month);
  end;
end;

procedure TESBMonthSpinEditLink.SetEditorValue(s: string);
begin
  case MonthFormat of
  emfShortMonth: FEdit.MonthShort := s;
  emfLongMonth: FEdit.MonthLong := s;
  emfNumeric: FEdit.Month := StrToInt(s);
  end;
end;

procedure TESBMonthSpinEditLink.SetProperties;
begin
  inherited;
  TESBMonthSpinEdit(FEdit).EditorEnabled := FEditorEnabled;
  TESBMonthSpinEdit(FEdit).FlatSpinBtns := FFlatSpinBtns;
  TESBMonthSpinEdit(FEdit).Interval := FInterval;
  TESBMonthSpinEdit(FEdit).MonthFormat := FMonthFormat;
end;

{ TESBDOWSpinEditLink }

constructor TESBDOWSpinEditLink.Create(aOwner: TComponent);
begin
  inherited;
  WantKeyLeftRight := True;
  WantKeyUpDown := True;
  WantKeyHomeEnd := True;
  FInterval := 100;
  FEditorEnabled := True;
  FDOWFormat := edfShortDOW; 
end;

procedure TESBDOWSpinEditLink.CreateEditor(aParent: TWinControl);
begin
  inherited;
  FEdit := TESBDOWSpinEdit.Create(aParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
  FEdit.ColorBorderFocus := clWindow;
  FEdit.ColorBorderUnFocus := clWindow;
  FEdit.FlatEdit := True;
end;

procedure TESBDOWSpinEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBDOWSpinEditLink.EditExit(sender: TObject);
begin
  HideEditor;
end;

function TESBDOWSpinEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBDOWSpinEditLink.GetEditorValue: string;
begin
  case FDOWFormat of
  edfShortDOW: Result := FEdit.DOWShort;
  edfLongDOW: Result := FEdit.DOWLong;
  edfNumeric: Result := IntToStr(FEdit.DOW);
  end;
end;

procedure TESBDOWSpinEditLink.SetEditorValue(s: string);
begin
  case FDOWFormat of
  edfShortDOW: FEdit.DOWShort := s;
  edfLongDOW: FEdit.DOWLong := s;
  edfNumeric: FEdit.DOW := StrToInt(s);
  end;
end;

procedure TESBDOWSpinEditLink.SetProperties;
begin
  inherited;
  TESBDOWSpinEdit(FEdit).EditorEnabled := FEditorEnabled;
  TESBDOWSpinEdit(FEdit).FlatSpinBtns := FFlatSpinBtns;
  TESBDOWSpinEdit(FEdit).Interval := FInterval;
  TESBDOWSpinEdit(FEdit).DOWFormat := FDOWFormat;
end;

{ TESBMonthComboBoxEditLink }

constructor TESBMonthComboBoxEditLink.Create(AOwner: TComponent);
begin
  inherited;
  WantKeyUpDown := True;
  WantKeyPriorNext := True;
  WantKeyHomeEnd := True;
  FMonthFormat := emfShortMonth;
end;

procedure TESBMonthComboBoxEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  FEdit := TESBMonthComboBox.Create(AParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
end;

procedure TESBMonthComboBoxEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBMonthComboBoxEditLink.EditExit(Sender: TObject);
begin
  HideEditor;
end;

function TESBMonthComboBoxEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBMonthComboBoxEditLink.GetEditorValue: string;
begin
  Result := FEdit.MonthLong;
end;

procedure TESBMonthComboBoxEditLink.SetEditorValue(s: string);
begin
  if (s <> '') then
  FEdit.MonthLong := s;
end;

procedure TESBMonthComboBoxEditLink.SetProperties;
begin
  inherited;
  FEdit.Flat := True;
  FEdit.ColorBorderFocus := clWindow;
  FEdit.ColorBorderUnfocus := clWindow;
  FEdit.MonthFormat := FMonthFormat;
end;

procedure TESBMonthComboBoxEditLink.SetRect(r: TRect);
begin
  inherited;
  FEdit.Height := 100;
end;

{ TESBDowComboBoxEditLink }

constructor TESBDowComboBoxEditLink.Create(aOwner: TComponent);
begin
  inherited;
  WantKeyUpDown := True;
  WantKeyPriorNext := True;
  WantKeyHomeEnd := True;
  FDOWFormat := edfShortDOW;
end;

procedure TESBDowComboBoxEditLink.CreateEditor(aParent: TWinControl);
begin
  inherited;
  FEdit:= TESBDowComboBox.Create(AParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
end;

procedure TESBDowComboBoxEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBDowComboBoxEditLink.EditExit(sender: TObject);
begin
  HideEditor;
end;

function TESBDowComboBoxEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBDowComboBoxEditLink.GetEditorValue: string;
begin
  case FDOWFormat of
  edfShortDOW: Result := FEdit.DOWShort;
  edfLongDOW: Result := FEdit.DOWLong;
  edfNumeric: Result := IntToStr(FEdit.DOW);
  end;
end;

procedure TESBDowComboBoxEditLink.SetEditorValue(s: string);
begin
  case FDOWFormat of
  edfShortDOW: FEdit.DOWShort := s;
  edfLongDOW: FEdit.DOWLong := s;
  edfNumeric: if s <> '' then FEdit.DOW := StrToInt(s);
  end;
end;

procedure TESBDowComboBoxEditLink.SetProperties;
begin
  inherited;
  FEdit.DOWFormat := FDOWFormat;
  FEdit.Flat := True;
  FEdit.ColorBorderFocus := clWindow;
  FEdit.ColorBorderUnfocus := clWindow;
end;

procedure TESBDowComboBoxEditLink.SetRect(r: TRect);
begin
  inherited;
  FEdit.Height := 100;
end;

{ TESBTZComboBoxEditLink }

constructor TESBTZComboBoxEditLink.Create(AOwner: TComponent);
begin
  inherited;
  WantKeyUpDown := True;
  WantKeyPriorNext := True;
  WantKeyHomeEnd := True;
end;

procedure TESBTZComboBoxEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  FEdit := TESBTZComboBox.Create(aParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
end;

procedure TESBTZComboBoxEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBTZComboBoxEditLink.EditExit(sender: TObject);
begin
  HideEditor;
end;

function TESBTZComboBoxEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBTZComboBoxEditLink.GetEditorValue: string;
begin
  if FEdit.ItemIndex >= 0 then
    Result := FEdit.Items[FEdit.ItemIndex]
  else Result := '';
end;

procedure TESBTZComboBoxEditLink.SetEditorValue(s: string);
begin
  if (s <> '') then FEdit.DisplayName := s;
end;

procedure TESBTZComboBoxEditLink.SetProperties;
begin
  inherited;
  FEdit.Flat := True;
  FEdit.ColorBorderFocus := clWindow;
  FEdit.ColorBorderUnfocus := clWindow;
  FEdit.DaylightBIAS := FDaylightBIAS;
  FEdit.DaylightDate := FDaylightDate;
  FEdit.DaylightName := FDaylightName;
end;

procedure TESBTZComboBoxEditLink.SetRect(r: TRect);
begin
  inherited;
  FEdit.Height := 100;
end;

{ TESBEMUComboBoxEditLink }

constructor TESBEMUComboBoxEditLink.Create(AOwner: TComponent);
begin
  inherited;
  WantKeyUpDown := True;
  WantKeyPriorNext := True;
  WantKeyHomeEnd := True;
end;

procedure TESBEMUComboBoxEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  FEdit := TESBEMUComboBox.Create(AParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
  FEMUFormat := eefShortEMU;
end;

procedure TESBEMUComboBoxEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBEMUComboBoxEditLink.EditExit(Sender: TObject);
begin
  HideEditor;
end;

function TESBEMUComboBoxEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBEMUComboBoxEditLink.GetEditorValue: string;
begin
  FEdit.EMUFormat := eefShortEMU;
  if FEdit.EMU>0 then Result := FEdit.EMUShort;
end;

procedure TESBEMUComboBoxEditLink.SetEditorValue(s: string);
begin
  if (s <> '') then FEdit.EMUShort := s;
end;

procedure TESBEMUComboBoxEditLink.SetProperties;
begin
  inherited;
  FEdit.Flat := True;
  FEdit.ColorBorderFocus := clWindow;
  FEdit.ColorBorderUnfocus := clWindow;
  FEdit.EMUFormat := eefShortEMU;
end;

procedure TESBEMUComboBoxEditLink.SetRect(r: TRect);
begin
  inherited;
  FEdit.Height := 100;
end;

{ TESBEMUComboBoxEditLink }

constructor TESBCountryComboBoxEditLink.Create(AOwner: TComponent);
begin
  inherited;
  WantKeyUpDown := True;
  WantKeyPriorNext := True;
  WantKeyHomeEnd := True;
end;

procedure TESBCountryComboBoxEditLink.CreateEditor(AParent: TWinControl);
var
  s: string;

begin
  inherited;
  FEdit := TESBCountryComboBox.Create(AParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;

  S := GetESBPCSXMLPath (2); // This gets the Path of the XML Dir from the ESBPCS 2
  if S = '' then // Otherwise assume that the file is in the Application Dir
    S := ExtractFilePath (Application.ExeName);

  if FileExists (S + 'esbcountry.xml') then
  begin
    ReadCountryList (ESBCountryList, S + 'esbcountry.xml');
    // Set the Default Country List
    FEdit.LoadItems; // Update Display
  end;
end;

procedure TESBCountryComboBoxEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBCountryComboBoxEditLink.EditExit(Sender: TObject);
begin
  HideEditor;
end;

function TESBCountryComboBoxEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBCountryComboBoxEditLink.GetEditorValue: string;
begin
  if FEdit.ItemIndex >= 0 then
    Result := FEdit.Items[FEdit.ItemIndex];
end;

procedure TESBCountryComboBoxEditLink.SetEditorValue(s: string);
begin
   if (s <> '') then FEdit.DisplayName := s;
end;

procedure TESBCountryComboBoxEditLink.SetProperties;
begin
  inherited;
  FEdit.Flat := True;
  FEdit.ColorBorderFocus := clWindow;
  FEdit.ColorBorderUnfocus := clWindow;
end;

procedure TESBCountryComboBoxEditLink.SetRect(r: TRect);
begin
  inherited;
  FEdit.Height := 100;
end;


{ TESBCalcEditLink }

{
constructor TESBCalcEditLink.Create(AOwner: TComponent);
begin
  inherited;
  WantKeyLeftRight := True;
  WantKeyHomeEnd := True;
end;

procedure TESBCalcEditLink.CreateEditor(AParent: TWinControl);
begin
  inherited;
  CreateInstance(AParent);
  FEdit.OnKeydown := EditKeyDown;
  FEdit.OnExit := EditExit;
  FEdit.Top := 0;
  FEdit.Left := 0;
  FEdit.Width := 0;
  FEdit.Height := 0;
  FEdit.Parent := AParent;
  FEdit.ColorBorderFocus := clWindow;
  FEdit.ColorBorderUnFocus := clWindow;
end;

procedure TESBCalcEditLink.CreateInstance(AParent: TWinControl);
begin
  FEdit := TESBCalcEdit.Create(AParent);
end;

procedure TESBCalcEditLink.DestroyEditor;
begin
  if Assigned(FEdit) then FEdit.Free;
  FEdit := nil;
  inherited;
end;

procedure TESBCalcEditLink.EditExit(sender: TObject);
begin
  HideEditor;
end;

function TESBCalcEditLink.GetEditControl: TWinControl;
begin
  Result := FEdit;
end;

function TESBCalcEditLink.GetEditorValue: string;
begin
  Result := FEdit.Text;
end;


procedure TESBCalcEditLink.SetEditorValue(s: string);
begin
  FEdit.Text := s;
end;

procedure TESBCalcEditLink.SetProperties;
begin
  inherited;
end;
}

procedure Register;
begin
 RegisterComponents('TMS EditLinks', [
 TESBComplexEditLink,
 TESBFractionEditLink,
 TESBPCSEditLink,
 TESBPosEditLink,
 TESBIntEditLink,
 TESBPosFloatEditLink,
 TESBFloatEditLink,
 TESBSciFloatEditLink,
 TESBPercentEditLink,
 TESBIPEditLink,
 TESBHexEditLink,
 TESBYearEditLink,
 TESBDateEditLink,
 TESBTimeEditLink,
 TESBDOWEditLink,
 TESBMonthEditLink,
 TESBCurrEditLink,
 TESBLongCurrEditLink,
 TESBCurrencyEditLink,
 TESBPosSpinEditLink,
 TESBIntSpinEditLink,
 TESBFloatSpinEditLink,
 TESBYearSpinEditLink,
 TESBMonthSpinEditLink,
 TESBDOWSpinEditLink,
 TESBMonthComboBoxEditLink,
 TESBDowComboBoxEditLink,
 TESBTZComboBoxEditLink,
 TESBEMUComboBoxEditLink,
 TESBCountryComboBoxEditLink
 ]);
end;



end.
